//////////////////////////////////////////////////////////
// Single Author Info
//   jjwinega  Joel J. Winegarden
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////

#include <config.h>
#include <conio.h>
#include <dsensor.h>
#include <dmotor.h>
#include <semaphore.h>
#include <lnp.h>
#include <lnp-logical.h>


//#define ROTATION_SENSOR            SENSOR_2

// motor speed for turning
#define TURN_SPEED		 20 //105

//#define ONE_TURN 0x10

#define MY_PORT 2

// turn directions
enum
{
	STOP = 0,
   RIGHT,
   LEFT
};

char msg; // msg contents received from IR
int newmsg = 0; // whether a new msg has been received
sem_t turn_wait_sem; // to allow indefinite turning


// shutoff the motors
static void shutoff_motors() {
   motor_c_speed(0);
}

/*static wakeup_t wait_clicks(wakeup_t clicks) {
	if(clicks>0)
		return ROTATION_2 >= (unsigned int)clicks;
	else
		return ROTATION_2 <= (unsigned int)clicks;
}*/

// turn left by making the C motor forward and the A motor reverse.
static void turn_left() { //int duration) {
	//ds_rotation_set(&ROTATION_SENSOR,duration);
   motor_c_dir(fwd);
   motor_c_speed(TURN_SPEED);
	//wait_event(wait_clicks,0);
	//shutoff_motors();
}

// turn right by making the A motor forward and the C motor reverse.
static void turn_right() { //int duration) {
	//ds_rotation_set(&ROTATION_SENSOR,0);
   motor_c_dir(rev);
   motor_c_speed(TURN_SPEED);
	//wait_event(wait_clicks,duration);
	//shutoff_motors();
}

// turn left until told to stop
static int turn_left_indefinitely(int argc,char** argv) {
	turn_left();
	sem_wait(&turn_wait_sem);
	return 0;
}

// turn right until told to stop
static int turn_right_indefinitely(int argc,char** argv) {
	turn_right();
	sem_wait(&turn_wait_sem);
	return 0;
}

// wait for a new msg to be received from IR
static wakeup_t wait_newmsg(wakeup_t dummy) {
	return (wakeup_t)newmsg;
}

// move the camera when told to do so via msgs from IR
static void move_cam() {
	int prev_msg = STOP;
	sem_init(&turn_wait_sem,0,0);
	while(!shutdown_requested()) {
		wait_event(wait_newmsg,0);
		sem_post(&turn_wait_sem);
		newmsg = 0;
		shutoff_motors();
		cputw(msg);
		if(msg==LEFT) {
			execi(turn_left_indefinitely,0,NULL,PRIO_NORMAL,DEFAULT_STACK_SIZE);
		}
		else if(msg==RIGHT) {
			execi(turn_right_indefinitely,0,NULL,PRIO_NORMAL,DEFAULT_STACK_SIZE);
		}
		prev_msg = msg;
	}
}

// handle incoming msgs 
void message_handler(const unsigned char* data,unsigned char length, unsigned char src) {
	msg = data[0];
	newmsg = 1;
}

// argc and argv are not used
int main(int argc, char *argv[])
{
	lnp_logical_range(1);
	lnp_addressing_set_handler(MY_PORT, message_handler);
	//ds_active(&ROTATION_SENSOR);
	move_cam();
	lnp_addressing_set_handler(MY_PORT,LNP_DUMMY_ADDRESSING);
	shutoff_motors();
   return 0;
}
