//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////

#ifndef APPWINDOW_H
#define APPWINDOW_H


#include <qmainwindow.h>

#include "ctimgproc.h"
#include "ctcanvasitem.h"
#include "ctcontroller.h"

class QCanvas;
class QCanvasView;
class QCanvasSprite;
class QCanvasPixmapArray;

class AppWindow : public QMainWindow, public CTImgProcListener
{
      Q_OBJECT

   public:
      AppWindow();

      void imageProcessed( Image* img, Rect* rect );

      inline void setController( CTController* controller );
      inline void setImgProc( CTImgProc* imgproc );

   private:
      void createCanvas();
      void createMenuBarItems();

   public slots:
      void openFile();
      void showCameraProps();
      void showImageProps();
      void showSelectColor();

   protected:
      QCanvas*          m_canvas;
      QCanvasView*      m_canvas_view;

      CTCanvasItem*     m_ctcanvas;
      CTImgProc*        m_ctimgproc;

      QColor            m_last_sel_color;
};

void AppWindow::setController( CTController* controller )
{
   m_ctcanvas->setController( controller );
}

void AppWindow::setImgProc( CTImgProc* imgproc )
{
   m_ctimgproc = imgproc;
   m_ctcanvas->setImgProc( imgproc );
}

#endif
