//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////

#include "boxfilter.h"

#include <stdlib.h>

BoxFilter::BoxFilter()
{
   m_box = NULL;
   m_size = 0;
}

BoxFilter::BoxFilter(int _size)
{
   m_box = NULL;

   allocBox( _size );
}

BoxFilter::~BoxFilter()
{
   if( m_box != NULL )
      deallocBox();
}

void BoxFilter::allocBox(int _size)
{
   if( m_box != NULL )
      deallocBox();

   m_box = new float* [_size];
   for( int i=0; i<_size; i++ )
      m_box[i] = new float [_size];

   m_size = _size;
}

void BoxFilter::deallocBox()
{
   for( int i=0; i<m_size; i++ )
      delete[] m_box[i];
   delete[] m_box;
}


BlurFilter::BlurFilter(int _size) : BoxFilter(_size)
{
   fillBox();
}

BlurFilter::~BlurFilter()
{
}

void BlurFilter::create(int _size)
{
   allocBox( _size );

   fillBox();
}

void BlurFilter::fillBox()
{
   float frac = 1.0 / (m_size * m_size);

   for( int x = 0; x < m_size; x++ )
      for( int y = 0; y < m_size; y++ )
         m_box[x][y] = frac;
}
