//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////

#ifndef BOXFILTER_H
#define BOXFILTER_H


class BoxFilter
{
   public:
      BoxFilter();
      BoxFilter(int _size);
      virtual ~BoxFilter();

      float* operator [](int i) { return m_box[i]; }

      float value(int x, int y) { return m_box[x][y]; }
      int size() { return m_size; }

   protected:
      void allocBox(int _size);
      void deallocBox();

   protected:
      int         m_size;
      float**     m_box;
};

class BlurFilter : public BoxFilter
{
   public:
      BlurFilter(int _size);
      ~BlurFilter();

      void create(int _size);

   private:
      void fillBox();
};

#endif
