//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////


#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>

#include "campropdlg.h"
#include "v4lcamera.h"

CamPropDlg::CamPropDlg( QWidget* parent, V4LCamera* camera ) :
   QDialog( parent, "CamProps", TRUE )
{
   m_camera = camera;

   bool valid_camera = false;
   
   V4LCamera::CamInfo caminfo;

   if( m_camera != NULL && m_camera->isOpen() )
   {
      m_camera->getInfo( &caminfo );
      valid_camera = true;
   }
   
   setCaption( "Camera Properties" );

   main_vbox = new QVBoxLayout( this );

   grid = new QGridLayout( main_vbox, 2 );

   grid->addWidget( new QLabel( "Device:", this ), 0, 0 );
   if( valid_camera )
      grid->addWidget( new QLabel( caminfo.device_name, this ), 0, 1 );

   grid->addWidget( new QLabel( "Name:", this ), 1, 0 );
   if( valid_camera )
      grid->addWidget( new QLabel( caminfo.name, this ), 1, 1 );

   QPushButton* ok_button = new QPushButton( "OK", this );
   QPushButton* cancel_button = new QPushButton( "Cancel", this );
   
   QHBoxLayout* buttons = new QHBoxLayout( main_vbox );
   buttons->addWidget( ok_button );
   buttons->addWidget( cancel_button );

   connect( ok_button, SIGNAL( clicked() ), this, SLOT( accept() ) );
   connect( cancel_button, SIGNAL( clicked() ), this, SLOT( reject() ) );

}

CamPropDlg::~CamPropDlg()
{
   delete grid;
   delete main_vbox;
}

