//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////

#ifndef CTCANVASITEM_H
#define CTCANVASITEM_H


#include <qimage.h>
#include <qcanvas.h>
#include <qpainter.h>
#include <qevent.h>

#include "ctimgproc.h"
#include "image.h"
#include "ctcontroller.h"

class CTCanvasItem : public QCanvasPolygon, public CTImgProcListener
{
   public:
      static const int RTTI;

   public:
      CTCanvasItem( QCanvas* canvas );
      ~CTCanvasItem();

      void imageProcessed( Image* img, Rect* rect );

      inline void setController( CTController* controller );
      inline void setImgProc( CTImgProc* imgproc );

      void mousePressEvent( QMouseEvent* e );

      virtual int rtti() const { return RTTI; }

   protected:
      virtual void drawShape( QPainter& painter );
      
   private:
      QImage    m_qimage;

      QRect     m_qrect;
      bool      m_draw_rect;

      Image*    m_last_img;

      CTController*     m_controller;
      CTImgProc*        m_imgproc;
};


void CTCanvasItem::setController( CTController* controller )
{
   m_controller = controller;
}

void CTCanvasItem::setImgProc( CTImgProc* imgproc )
{
   m_imgproc = imgproc;
}

#endif
