//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////

#include "ctcanvasview.h"

#include "ctcanvasitem.h"

CTCanvasView::CTCanvasView( QWidget* parent ) : QCanvasView( parent,
                                                             "canvas view" )
{
}



void CTCanvasView::contentsMousePressEvent( QMouseEvent* e )
{
   if( e->button() == Qt::LeftButton )
   {
      QCanvasItemList cil = canvas()->collisions( e->pos() );
      QCanvasItemList::Iterator item;

      for( item = cil.begin(); item != cil.end(); item++ )
      {
         if( (*item)->rtti() == CTCanvasItem::RTTI )
         {
            CTCanvasItem* ctci = (CTCanvasItem*) (*item);
            ctci->mousePressEvent( e );

            break;
         }
      }
   }
}

void CTCanvasView::contentsMouseMoveEvent( QMouseEvent* e )
{
   if( e->state() & Qt::LeftButton )
   {
      QCanvasItemList cil = canvas()->collisions( e->pos() );
      QCanvasItemList::Iterator item;

      for( item = cil.begin(); item != cil.end(); item++ )
      {
         if( (*item)->rtti() == CTCanvasItem::RTTI )
         {
            CTCanvasItem* ctci = (CTCanvasItem*) (*item);
            ctci->mousePressEvent( e );

            break;
         }
      }
   }
}

