//////////////////////////////////////////////////////////////////
// Single Author Info
//   dehuber  Daniel E. Huber
//
// Group Info
//   dehuber  Daniel E. Huber
//   jjwinega Joel J. Winegarden
//////////////////////////////////////////////////////////////////

#ifndef TIMER_H
#define TIMER_H


class Timer
{
   public:
      struct Period
      {
            unsigned int sec;
            unsigned int usec;
      };

   public:
      Timer();

      void create( Period* period, void (*callback)(void*), void* arg );

      void start();

      void stop();

   private:
      void runTimerThread();

      friend void* timer_thread_wrap( void* timer );
      
   private:
      Period            m_period;
      void (*m_callback)(void*);
      void*             m_arg;

      bool              m_running;
};


#endif
